#include<iostream>
#include<cmath>
using namespace std;

const int MAXN=2e5, INF=1e9;
const int MAXM=(1<<(int)ceil(log2(MAXN)));

int seg[2*MAXM+1], l[2*MAXM+1], r[2*MAXM+1], nSize[2*MAXM+1];
int a[MAXN];

void InitSegTree(int n)
{
    int m=(1<<(int)ceil(log2(n)));
    for(int i=0; i<m; i++)
    {
        seg[i+m]=-INF;
        l[i+m]=-INF;
        r[i+m]=-INF;
        nSize[i+m]=1;
    }

    for(int i=m-1; i>0; i--)
    {
        seg[i]=-INF;
        l[i]=-INF;
        r[i]=-INF;
        nSize[i]=nSize[2*i]+nSize[2*i+1];
    }

    return;
}

void UpdateTree(int idx)
{
    if(idx==0)
    {
        return;
    }

    l[idx]=l[2*idx];
    r[idx]=r[2*idx+1];

    int mid=0;
    if(r[2*idx]>0)
    {
        mid+=r[2*idx];

        if(r[2*idx+1]==nSize[2*idx+1])
        {
            r[idx]+=r[2*idx];
        }
    }

    if(l[2*idx+1]>0)
    {
        mid+=l[2*idx+1];

        if(l[2*idx]==nSize[2*idx])
        {
            l[idx]+=l[2*idx+1];
        }
    }

    seg[idx]=max(mid, max(seg[2*idx], seg[2*idx+1]));

    UpdateTree(idx/2);

    return;
}

void SetNumber(int n, int idx, bool active)
{
    int m=(1<<(int)ceil(log2(n)));
    if(active)
    {
        seg[idx+m]=1;
        l[idx+m]=1;
        r[idx+m]=1;
    }
    else
    {
        seg[idx+m]=-INF;
        l[idx+m]=-INF;
        r[idx+m]=-INF;
    }

    UpdateTree((idx+m)/2);

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    for(int i=0; i<n; i++)
    {
        cin >> a[i];
        a[i]--;
    }

    InitSegTree(n);

    while(q--)
    {
        int l1, r1;
        cin >> l1 >> r1;
        l1--, r1--;

        for(int i=l1; i<=r1; i++)
        {
            SetNumber(n, a[i], true);
        }

        cout << seg[1] << "\n";

        for(int i=l1; i<=r1; i++)
        {
            SetNumber(n, a[i], false);
        }
    }

    return 0;
}
