#include<iostream>
using namespace std;

const long long INF=1e7, MOD=1050000011;
const int MAXN=1e3+10;

long long dp[MAXN][MAXN];

long long GetPow(int x, int k)
{
    if(k==0)
    {
        return 1;
    }

    if(k%2==0)
    {
        long long p=GetPow(x, k/2);
        p=p*p;

        return min(p, INF);
    }

    return min(GetPow(x, k-1)*x, INF);
}

long long GetRoot(int x, int k)
{
    if(x==1)
    {
        return 1;
    }

    int l=1, r=x, ans=-1;
    while(l<r)
    {
        int mid=l+(r-l)/2;
        if(GetPow(mid, k)<=x)
        {
            ans=mid;
            l=mid+1;
        }
        else
        {
            r=mid-1;
        }
    }

    return ans;
}

long long GetAns(int currPow, int n, int m)
{
    if(m==-1)
    {
        return 0;
    }

    if(currPow==n+1)
    {
        return 1;
    }

    if(m==0)
    {
        return 0;
    }

    if(dp[currPow][m]==-1)
    {
        dp[currPow][m]=(GetAns(currPow, n, m-1)+GetAns(currPow+1, n, GetRoot(m, currPow)))%MOD;
    }

    return dp[currPow][m];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i=0; i<=n; i++)
    {
        for(int j=0; j<=m; j++)
        {
            dp[i][j]=-1;
        }
    }

    cout << GetAns(1, n, m) << "\n";

    return 0;
}
