#include<iostream>
#include<vector>
#include<cstdlib>
using namespace std;

const int MAX_SIZE = 2*10e5;

int nums[MAX_SIZE];
vector<pair<int, int>> longest[MAX_SIZE];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i) {
        int value;
        cin >> value;
        nums[i] = value;
        longest[i].push_back(make_pair(i, 1));
    }

    int maxsub = 1;
    for (int i = 0; i < n; ++i) {
        vector<pair<int, int>> missing;
        int maxn = i, minn = i;

        int curr = 1;
        for (int j = i; j < n; ++j) {
            if (nums[j] > nums[maxn]) {
                if (nums[j] - nums[maxn] > 1) {
                    // cout << "Attempting to jump from " << nums[maxn] << " to " << nums[j] << endl;
                    missing.push_back(make_pair(nums[maxn] + 1, nums[j] - 1));
                }
                maxn = j;
            }
            if (nums[j] < nums[minn]) {
                if (nums[minn] - nums[j] > 1) {
                    // cout << "Attempting to jump from " << nums[minn] << " to " << nums[j] << endl;
                    missing.push_back(make_pair(nums[j] + 1, nums[minn] - 1));
                }
                minn = j;
            }

            vector<int> to_delete;
            vector<pair<int, int>> split;
            for (int k = missing.size() - 1; k >= 0; --k) {
                if (!(nums[j] >= missing[k].first && nums[j] <= missing[k].second))
                    continue;

                if (missing[k].first == missing[k].second) {
                    // cout << "Connecting point discontinuity " << missing[k].first << endl;
                    to_delete.push_back(k);
                    continue;
                }
                if (missing[k].first == nums[j]) {
                    // cout << "Increasing lower bound of missing from " << missing[k].first << " to " << missing[k].first + 1 << " which goes to " << missing[k].second << endl;
                    ++missing[k].first;
                    continue;
                }
                if (missing[k].second == nums[j]) {
                    // cout << "Decreasing upper bound of missing from " << missing[k].second << " to " << missing[k].second - 1 << " which goes to " << missing[k].first << endl;
                    --missing[k].second;
                    continue;
                }

                split.push_back(make_pair(missing[k].first, nums[j] - 1));
                split.push_back(make_pair(nums[j] + 1, missing[k].second));
                to_delete.push_back(k);
            }

            for (int a = to_delete.size() - 1; a >= 0; --a)
                missing.erase(missing.begin() + to_delete[a], missing.begin() + to_delete[a] + 1);

            for (int sp = 0; sp < split.size(); ++sp)
                missing.push_back(split[sp]);

            int old = curr;
            if (missing.size() == 0) {
                if (j - i + 1 > curr)
                    curr = j - i + 1;
            }else{
                if (missing[0].first - nums[minn] > curr) {
                    curr = missing[0].first - nums[minn];
                }

                if (nums[maxn] - missing[missing.size() - 1].second > curr) {
                    curr = nums[maxn] - missing[missing.size() - 1].second;
                }

                for (int k = 0; k < missing.size() - 1; ++k)
                    if (missing[k + 1].first - missing[k].second - 1 > curr)
                        curr = missing[k + 1].first - missing[k].second - 1;
            }

            if (old != curr) {
                longest[i].push_back(make_pair(j, curr));
                // cout << "Max subsequence between " << i << " and " << j << " (and onwards) was " << old << "and is now " << curr << endl;
            }
        }
    }

    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;

        for (int k = 0; k < longest[l].size(); ++k) {
            // cout << "Left: " << l << " Pair #" << k << " max subseq " << longest[l][k].second << " from " << longest[l][k].first << endl;
            // cout << "Starting from Left " << l << " and reaching bound " << longest[l][k].first << " has max subseq " << longest[l][k].second << endl;
            if (r >= longest[l][k].first && k == longest[l].size() - 1) {
                cout << longest[l][k].second << endl;
                break;
            }
            if (r >= longest[l][k].first && r < longest[l][k + 1].first) {
                cout << longest[l][k].second << endl;
                break;
            }
            // cout << "ERROR";
        }
    }

    return 0;
}
