#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

#define endl '\n'

using namespace std;

struct Project
{
    double difficulty;
    int index;

    Project(): difficulty(0.0), index(-1) {}

    Project(double _difficulty, int _index)
    {
        difficulty = _difficulty;
        index = _index;
    }

    bool operator<(const Project& comp)
    {
        return difficulty < comp.difficulty;
    }
};

const int MAXN = 1e5 + 3;

Project projects[MAXN];

int programmers_count_result[MAXN];
int programmers_count_current[MAXN];

void find_arrangement(int ind, int workers, double productivity, double& res, vector<Project>& available, int n)
{
    if (ind == (int) available.size())
    {
        if (workers == 0 and productivity > res)
        {
            res = productivity;
            for (int i = 0; i < n; ++i)
            {
                programmers_count_result[i] = programmers_count_current[i];
            }
        }

        return;
    }

    for (int counter = 0; counter <= workers; ++counter)
    {
        double current_project = sqrt(counter) / available[ind].difficulty;

        programmers_count_current[available[ind].index] = counter;
        find_arrangement(ind + 1, workers - counter, productivity + current_project, res, available, n);
        programmers_count_current[available[ind].index] = 0;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i)
    {
        double x;
        cin >> x;

        projects[i] = {x, i};
    }

    sort(projects, projects + n);

    vector<Project> available;

    for (int i = 0; i < min(n, 10); ++i)
    {
        available.push_back(projects[i]);
    }

    double res = -1;
    find_arrangement(0, k, 0.0, res, available, n);

    for (int i = 0; i < n; ++i)
    {
        cout << programmers_count_result[i] << " ";
    }
    cout << endl;

    return 0;
}
