#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>

#define endl '\n'

using namespace std;

struct Project
{
    double difficulty;
    int index;

    Project(): difficulty(0.0), index(-1) {}

    Project(double _difficulty, int _index)
    {
        difficulty = _difficulty;
        index = _index;
    }

    bool operator<(const Project& comp)
    {
        return difficulty < comp.difficulty;
    }
};

const int MAXN = 1e5 + 3;
const int MAXK = 1e4 + 3;

Project projects[MAXN];

double dp[MAXK][MAXK];
int workers_for_dp[MAXK][MAXK];

int programmers_count_result[MAXN];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i)
    {
        double x;
        cin >> x;

        projects[i] = {x, i};
    }

    sort(projects, projects + n);

    vector<Project> available;

    for (int i = 0; i < min(n, k); ++i)
    {
        available.push_back(projects[i]);
    }

    for (int i = 1; i <= min(n, k); ++i)
    {
        for (int j = 0; j <= k; ++j)
        {
            for (int used_workers = j; used_workers >= 0; --used_workers)
            {
                double productivity = sqrt(used_workers) / projects[i - 1].difficulty;
                double new_dp = dp[i - 1][j - used_workers] + productivity;

                if (new_dp > dp[i][j])
                {
                    dp[i][j] = new_dp;
                    workers_for_dp[i][j] = used_workers;
                }
                else
                {
                    break;
                }
            }
        }
    }

    int left_workers = k;
    for (int i = min(n, k); i >= 1; --i)
    {
        int current_index = projects[i - 1].index;
        int current_workers = workers_for_dp[i][left_workers];

        programmers_count_result[current_index] = current_workers;

        left_workers -= current_workers;
    }

    for (int i = 0; i < n; ++i)
    {
        cout << programmers_count_result[i] << " ";
    }
    cout << endl;

    return 0;
}

