#include <iostream>

#define endl '\n'
#define int uint64_t

using namespace std;

const int MOD = 1050000011;
const int MAXN = 1e4 + 3;

int dp[MAXN][MAXN];
int biggest_pow[MAXN];

void add_mod(int &x, int y)
{
    x += y;
    if (x >= MOD)
    {
        x -= MOD;
    }
}

int calc_pow(int a, int b)
{
    int res = 1;

    for (int i = 0; i < b; ++i)
    {
        res *= a;
    }

    return res;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    biggest_pow[0] = biggest_pow[1] = m;
    for (int i = 2; i <= n; ++i)
    {
        biggest_pow[i] = 2;

        while (biggest_pow[i] <= biggest_pow[i - 1])
        {
            if (calc_pow(biggest_pow[i], i) > m)
            {
                break;
            }

            ++biggest_pow[i];
        }

        --biggest_pow[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        dp[1][i] = 1;
    }

    for (int nums = 2; nums <= n; ++nums)
    {
        for (int last_num = 1; last_num <= biggest_pow[nums]; ++last_num)
        {
            for (int prev = biggest_pow[nums - 1]; calc_pow(prev, nums - 1) >= calc_pow(last_num, nums); --prev)
            {
                add_mod(dp[nums][last_num], dp[nums - 1][prev]);
            }
        }
    }

    int res = 0;
    for (int i = 1; i <= biggest_pow[n]; ++i)
    {
        add_mod(res, dp[n][i]);
    }

    cout << res << endl;

    return 0;
}
