#include <iostream>
#include <unordered_map>

#define endl '\n'
#define int uint64_t

using namespace std;

const int MOD = 1050000011;
const int MAXN = 1e6 + 3;

int dp[2][MAXN];
int biggest_pow[MAXN];

unordered_map<int, int> precalc_pow[MAXN];

void add_mod(int &x, int y)
{
    x += y;
    if (x >= MOD)
    {
        x -= MOD;
    }
}

int calc_pow(int a, int b)
{
    int res = 1;

    for (int i = 0; i < b; ++i)
    {
        res *= a;
    }

    return res;
}

int give_me_pow(int a, int b)
{
    if (!precalc_pow[a].count(b))
    {
        precalc_pow[a][b] = calc_pow(a, b);
    }

    return precalc_pow[a][b];
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        precalc_pow[i][1] = i;
    }

    biggest_pow[0] = biggest_pow[1] = m;
    for (int i = 2; i <= n; ++i)
    {
        biggest_pow[i] = 1;

        while (biggest_pow[i] <= biggest_pow[i - 1])
        {
            if (give_me_pow(biggest_pow[i], i) > m)
            {
                break;
            }

            ++biggest_pow[i];
        }

        --biggest_pow[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        dp[1][i] = 1;
    }

    for (int nums = 2; nums <= n; ++nums)
    {
        int curr = nums & 1;
        int prev = curr ^ 1;

        for (int i = 1; i <= biggest_pow[nums]; ++i)
        {
            dp[curr][i] = 0;
        }

        for (int last_num = 1; last_num <= biggest_pow[nums]; ++last_num)
        {
            for (int bigger = biggest_pow[nums - 1]; give_me_pow(bigger, nums - 1) >= give_me_pow(last_num, nums); --bigger)
            {
                add_mod(dp[curr][last_num], dp[prev][bigger]);
            }
        }
    }

    int res = 0;
    for (int i = 1; i <= biggest_pow[n]; ++i)
    {
        add_mod(res, dp[n & 1][i]);
    }

    cout << res << endl;

    return 0;
}
