#include <iostream>
#include <unordered_map>

#define endl '\n'
#define int uint64_t

using namespace std;

const int MOD = 1050000011;
const int MAXN = 1e6 + 3;

int dp[2][MAXN];
int prefix[MAXN];
int biggest_pow[MAXN];

unordered_map<int, int> precalc_pow[MAXN];

void add_mod(int &x, int y)
{
    x += y;
    if (x >= MOD)
    {
        x -= MOD;
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        precalc_pow[i][1] = i;
    }

    biggest_pow[0] = biggest_pow[1] = m;
    for (int i = 2; i <= n; ++i)
    {
        biggest_pow[i] = 1;

        while (biggest_pow[i] <= biggest_pow[i - 1])
        {
            precalc_pow[biggest_pow[i]][i] = precalc_pow[biggest_pow[i]][i - 1] * biggest_pow[i];

            if (precalc_pow[biggest_pow[i]][i] > m)
            {
                break;
            }

            ++biggest_pow[i];
        }

        --biggest_pow[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        dp[1][i] = 1;
    }

    prefix[m + 1] = 0;
    for (int i = m; i >= 1; --i)
    {
        prefix[i] = prefix[i + 1];
        add_mod(prefix[i], dp[1][i]);
    }

    for (int nums = 2; nums <= n; ++nums)
    {
        int curr = nums & 1;
        int prev = curr ^ 1;

        for (int i = 1; i <= biggest_pow[nums]; ++i)
        {
            dp[curr][i] = 0;
        }

        int bigger = biggest_pow[nums - 1];
        for (int last_num = biggest_pow[nums]; last_num >= 1; --last_num)
        {
            /*for (int bigger = biggest_pow[nums - 1]; precalc_pow[bigger][nums - 1] >= precalc_pow[last_num][nums]; --bigger)
            {
                add_mod(dp[curr][last_num], dp[prev][bigger]);
            }*/

            while (bigger > 0 and precalc_pow[bigger][nums - 1] >= precalc_pow[last_num][nums])
            {
                --bigger;
            }

            add_mod(dp[curr][last_num], prefix[bigger + 1]);
        }

        prefix[biggest_pow[nums] + 1] = 0;
        for (int i = biggest_pow[nums]; i >= 1; --i)
        {
            prefix[i] = prefix[i + 1];
            add_mod(prefix[i], dp[curr][i]);
        }
    }

    int res = 0;
    for (int i = 1; i <= biggest_pow[n]; ++i)
    {
        add_mod(res, dp[n & 1][i]);
    }

    cout << res << endl;

    return 0;
}
