#pragma GCC optimize ("O3")

#include <iostream>
#include <cstdint>
#include <queue>
#include <cmath>

#define MAX_N 1000006
#define MAX_K 1000000012

uint64_t n;
uint64_t k;
double   xs[MAX_N];
uint64_t ys[MAX_N];

struct Cache {
	uint64_t i;
	double bonus;
};

bool operator<(const Cache &a, const Cache &b) {
	return a.bonus < b.bonus;
}

std::priority_queue<Cache> pq;

void init_programmer_adding() {
	for (uint64_t i = 0; i < n; i += 1) {
		pq.push(Cache{
			.i = i,
			.bonus = 1/xs[i],
		});
	}
}

void add_one_programmer() {
	Cache top = pq.top();
	pq.pop();
	ys[top.i] += 1;
	pq.push(Cache{
		.i = top.i,
		.bonus = (sqrt(ys[top.i]+1) - sqrt(ys[top.i])) / xs[top.i],
	});
}

void print_ys(std::ostream &os) {
	for (uint64_t i = 0; i < n; i += 1) {
		os << ys[i] << " ";
	}
	os << std::endl;	
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> n >> k;
	for (uint64_t i = 0; i < n; i += 1) {
		std::cin >> xs[i];
	}
	
	init_programmer_adding();
	
	for (uint64_t i = 0; i < k; i += 1) {
		add_one_programmer();
		// print_ys(std::cerr);
	}
	
	print_ys(std::cout);
}