#pragma GCC optimize ("O3")

#include <iostream>
#include <cstdint>
#include <queue>
#include <cmath>
#include <algorithm>

#define MAX_N 1000006
#define MAX_K 1000000012

uint64_t n;
uint64_t k;
double   xs[MAX_N];
uint64_t ys[MAX_N];

void print_ys(std::ostream &os) {
	for (uint64_t i = 0; i < n; i += 1) {
		os << ys[i] << " ";
	}
	os << std::endl;	
}

double f(double x) {
	return 1 / x;
}

struct Guys_Idx {
	double guys;
	uint64_t idx;
};

bool operator<(const Guys_Idx &a, const Guys_Idx &b) {
	return a.guys > b.guys;
}

Guys_Idx guys_idx[MAX_N];

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> n >> k;
	for (uint64_t i = 0; i < n; i += 1) {
		std::cin >> xs[i];
	}
	
	double sum = 0;
	for (uint64_t i = 0; i < n; i += 1) {
		sum += f(xs[i]);
	}
	
	double dummy;
	
	for (uint64_t i = 0; i < n; i += 1) {
		double guys = f(xs[i]) / sum * k;
		ys[i] += guys;
		guys_idx[i] = Guys_Idx{
			.guys = modf(guys, &dummy),
			.idx = i,
		};
	}
	
	for (uint64_t i = 0; i < n; i += 1) {
		k -= ys[i];
	}

	std::sort(guys_idx, guys_idx+n);
	
	for (uint64_t i = 0; i < n; i += 1) {
		if (k == 0) break;
		k -= 1;
		ys[guys_idx[i].idx] += 1;
	}
	
	print_ys(std::cout);
}