#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
#define MAXN 200007
using namespace std;

struct event{
    int type,tim,pos,val;
};

const int bucket_sz=300;

int n,q,l,r,dsu[MAXN],sz[MAXN],cnt,sol[MAXN];
int p[MAXN],bucket[MAXN],tim,ans,comp[MAXN],s,li[MAXN],w[MAXN];
bool in[MAXN];
stack<event> st;

struct qr{
    int l,r,id;

    inline friend bool operator < (qr fr,qr sc){
        if(bucket[fr.l]!=bucket[sc.l])return bucket[fr.l] < bucket[sc.l];
        else if(fr.r!=sc.r)return fr.r<sc.r;
        else return fr.l>sc.l;
    }
};

vector<qr> qs;

void reset(){
    for(int i=1;i<=n;i++){
        dsu[i]=i; sz[i]=1; in[i]=false;
    }
    while(!st.empty())st.pop();
    tim=0; ans=1;
}

int root(int x){
    if(dsu[x]==x)return x;
    st.push({1,tim,x,dsu[x]});
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void check(int x){
    if(li[x]!=tim){
        comp[x]=x; w[x]=1;
    }
    li[x]=tim;
}

int parent(int x){
    check(x);
    if(comp[x]==x)return x;
    comp[x]=parent(comp[x]);
    return comp[x];
}

void connect(int x,int y){
    int r1=parent(x),r2=parent(y);
    if(r1==r2)return;

    if(w[r1]>w[r2])swap(r1,r2);

    comp[r1]=r2;
    w[r2]+=w[r1];
    s=max(s,w[r2]);
}

void mergev(int x,int y){
    tim++;
    int rootx=root(x);
    int rooty=root(y);

    if(rootx==rooty)return;

    if(sz[rootx]<sz[rooty])swap(rootx,rooty);
    st.push({1,tim,rooty,rooty});
    st.push({2,tim,rootx,sz[rootx]});
    st.push({3,tim,0,ans});

    dsu[rooty]=rootx;
    sz[rootx]+=sz[rooty];
    ans=max(ans,sz[rootx]);
}

void undo(){
    while(!st.empty() and st.top().tim==tim){
        if(st.top().type==1){
            dsu[st.top().pos]=st.top().val;
        }else if(st.top().type==2){
            sz[st.top().pos]=st.top().val;
        }else{
            ans=st.top().val;
        }
        st.pop();
    }
    tim--;
}

void add(int x){
    if(in[x-1])mergev(x-1,x);
    if(in[x+1])mergev(x+1,x);
    in[x]=true;
}

void rem(int x){
    if(in[x-1])undo();
    if(in[x+1])undo();
    in[x]=false;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>p[i];
        bucket[i]=i/bucket_sz;
    }

    for(int i=1;i<=q;i++){
        cin>>l>>r;
        if(bucket[l]+1>=bucket[r]){
            tim++; check(p[l]); s=1;
            for(int f=l+1;f<=r;f++){
                check(p[f]);
                if(li[p[f]-1]==tim)connect(p[f],p[f]-1);
                if(li[p[f]+1]==tim)connect(p[f],p[f]+1);
            }
            sol[i]=s;
        }else{
            qs.push_back({l,r,i});
        }
    }

    sort(qs.begin(),qs.end());

    for(int i=0;i<qs.size();i++){
        if(i==0 or bucket[qs[i].l]!=bucket[qs[i-1].l]){
            reset();
            l=(bucket[qs[i].l]+1)*bucket_sz;
            r=max((bucket[qs[i].l]+1)*bucket_sz-1,0);
        }

        while(r<qs[i].r){
            r++; add(p[r]);
        }

        while(l>qs[i].l){
            l--; add(p[l]);
        }

        sol[qs[i].id]=ans;
        if(i<qs.size()-1 and qs[i].r==qs[i+1].r and qs[i+1].l<qs[i].l)continue;

        while(l<(bucket[qs[i].l]+1)*bucket_sz){
            rem(p[l]); l++;
        }
    }

    for(int i=1;i<=q;i++){
        cout<<sol[i]<<"\n";
    }

    return 0;
}

