#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1e9 +7;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 2e4 + 10;
int arr[MAX_N];

struct node {
    int l, r, ans, cnt;

    node(bool on = false) {
        l = r = ans = on;
    }
    void flip() {
        l = r = ans = 1 - ans;
    }
};

node tree[4 * MAX_N];

void pull(int curr) {
    tree[curr].ans = max(tree[curr * 2].r + tree[curr * 2 + 1].l, max(tree[curr * 2].ans, tree[curr * 2 + 1].ans));
    if(tree[curr * 2].ans == tree[curr * 2].cnt) {
        tree[curr].l = tree[curr * 2].ans + tree[curr * 2 + 1].l;
    } else {
        tree[curr].l = tree[curr * 2].l;
    }
    if(tree[curr * 2 + 1].ans == tree[curr * 2 + 1].cnt) {
        tree[curr].r = tree[curr * 2 + 1].ans + tree[curr * 2].r;
    } else {
        tree[curr].r = tree[curr * 2 + 1].r;
    }
}

int n, q;
pair<pair<int, int>, int> quer[MAX_N];

void upd(int ind) {
    int curr = 1;
    int l = 0, r = n - 1;
    while(l != r) {
        int m = (l + r) / 2ll;
        if(ind <= m) {
            r = m;
            curr = curr * 2;
        } else {
            l = m + 1;
            curr = curr * 2 + 1;
        }
    }
    tree[curr].flip();
    curr /= 2;
    while(curr) {
        pull(curr);
        curr /= 2;
    }
}

void build(int curr, int l, int r) {
    tree[curr].cnt = (r - l + 1);
    if(l != r) {
        int m = (l + r) / 2ll;
        build(curr * 2, l, m);
        build(curr * 2 + 1, m + 1, r);
    }
}

void print(int curr, int l, int r) {
    cout << curr << " " << l << " " << r << " -> " << tree[curr].ans << " " << tree[curr].l << " " << tree[curr].r << endl;
    if(l != r) {
        int m = (l + r) / 2ll;
        print(curr * 2, l, m);
        print(curr * 2 + 1, m + 1, r);
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
        arr[i] --;
    }
    build(1, 0, n - 1);

    for(int i = 0; i < q; i ++) {
        cin >> quer[i].first.first >> quer[i].first.second;
        quer[i].first.first --;
        quer[i].first.second --;
        auto [l, r] = quer[i].first;
        for(int i = l; i <= r; i ++) { upd(arr[i]); }
        cout << tree[1].ans << endl;
        for(int i = l; i <= r; i ++) { upd(arr[i]); }
    }

    return 0;
}

