#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
// #pragma GCC target("avx2, tune=native")
#define endl "\n"

using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

typedef long long ll;
const ll mod = 1050000011;

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll MAX_N = 1e6 + 10;
ll n, m;

vector<pair<ll, ll> > digans[MAX_N];
vector<ll> prec[MAX_N];

void fix(auto &x) {
    if(x >= mod) {
        x -= mod;
    }
}

ll sqr(ll x) {
    ll l = 0;
    ll r = x + 1;

    while(l < r - 1) {
        ll m = (l + r) / 2ll;
        if(x / m >= m) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

ll fpow(ll x, ll p) {
    if(p == 0) { return 1; }
    ll ans = fpow(x, p / 2);
    ans = (ans * ans) % mod;
    if(p & 1) {
        return (ans * x) % mod;
    } else {
        return ans;
    }
}

ll inv6 = fpow(6, mod - 2);

ll sum(ll x) {
    return (2ll * x * x % mod + x) % mod * (x + 1) % mod * inv6 % mod;
}

void solve2() {
    ll sq = sqr(m);
    cout << ((m + 1) % mod * sq % mod - sum(sq) + mod) % mod << endl;;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    n = 10000000000000;
    m = 10000000000000;
    cin >> n >> m;

    if(n == 1) {
        cout << m % mod << endl;
        return 0;
    } else if(n == 2) {
        solve2();
        return 0;
    }

    ll now = 0;
    prec[2].push_back(1);
    for(ll i = 1; i * i <= m; i ++) {
        now = (now + m - i * i + 1) % mod;
        digans[2].push_back({i * i, now});
        prec[2].push_back((i + 1) * (i + 1));
    }

    ll last = -1;

    for(ll i = 3; i <= n; i ++) {
        ll now = 0;
        int ptr = 0;
        for(ll j = 1; true; j ++) {
            prec[i].push_back(prec[i - 1][j - 1] * j);
            ll pw = prec[i].back();
            if(pw > m) { break; } // TODO: Fix

            while(ptr + 1 < digans[i - 1].size() && digans[i - 1][ptr + 1].first < pw) { ptr ++; }

            if(ptr == 0) {
                now = (now + digans[i - 1].back().second);
                now = (now >= mod) ? now - mod : now;
            } else {
                now = (now + digans[i - 1].back().second - digans[i - 1][ptr].second + mod) % mod;
            }
            digans[i].push_back({pw, now});
        }
        if((1ll << i) > m) {
            if(last != -1) {
                break;
            } else {
                last = i + 1;
            }
        }
    }
    if(last == -1 || last == n + 1) {
        last = n;
    }

    ll ret = digans[last].back().second;

    cout << ret << endl;

    return 0;
}

/*
10000000000000
10000000000000
*/
