/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <cmath>
#include <queue>

typedef long long llong;
const int MAXN = 1000000 + 10;
const double EPS = 1e-7;
const int INF  = 1e9;

int n;
llong k;
llong y[MAXN];
long double x[MAXN];

llong binary(int idx, double penalty)
{
    llong l = 0, r = k + 1, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (sqrt(mid) - sqrt(mid - 1) > x[idx] * penalty) l = mid;
        else r = mid;
    }

    return l;
}

int check(long double penalty)
{
    int res = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        y[i] = binary(i, penalty);
        res += y[i];
    }

    return res;
}

struct Worker
{
    int idx;
    inline friend bool operator < (const Worker &a, const Worker &b)
    {
        return x[b.idx] * (sqrt(y[a.idx] + 1) - sqrt(y[a.idx])) < x[a.idx] * (sqrt(y[b.idx] + 1) - sqrt(y[b.idx]));
    }
};

std::priority_queue <Worker> pq;
void solve()
{
    long double l = 0.0, r = 1001.0, mid;
    while (r - l > EPS)
    {
        mid = (l + r) / 2.0;
        int res = check(mid);
        if (res == k)
        {
            for (int i = 1 ; i <= n ; ++i)
            {
                std::cout << y[i] << ' ';
            }

            std::cout << '\n';
            return;
        }

        if (res > k) l = mid;
        else r = mid;
    }

    int res = check(r);
    for (int i = 1 ; i <= n ; ++i)
    {
        pq.push({i});
    }

    while (res < k)
    {
        Worker top = pq.top();
        pq.pop();
        y[top.idx]++;
        pq.push(top);
        res++;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << y[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
