/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <queue>

typedef long long llong;
const int MAXN = 1000000 + 10;
const double EPS = 1e-4;
const int INF  = 1e9;

int n;
llong k;
llong y[MAXN];
long double x[MAXN];

llong binary(int idx, long double penalty)
{
    if (1.0 / x[idx] < penalty) return 0;
    long double c = x[idx] * penalty;
    // std::cout << "HERE: " << c << ' ' << (c * c) / 4.0 << ' '  << 1.0 / (4.0 * c * c) << '\n';
    llong currY = floor((c > EPS ? (c * c) / 4.0 : 0) + 1.0 / (4.0 * c * c) + 0.5);
    return currY;
}

int check(long double penalty)
{
    int res = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        y[i] = binary(i, penalty);
        res += y[i];
    }

    return res;
}

struct Worker
{
    int idx;
    long double diff;
    inline friend bool operator < (const Worker &a, const Worker &b)
    {
        return x[b.idx] * a.diff < x[a.idx] * b.diff;
    }
};

std::priority_queue <Worker> pq;
void solve()
{
    long double l = 0.0, r = 2.0, mid;
    while (true)
    {
        mid = (l + r) / 2.0;
        int res = check(mid);
        if (res == k)
        {
            for (int i = 1 ; i <= n ; ++i)
            {
                std::cout << y[i] << ' ';
            }

            std::cout << '\n';
            return;
        }

        if (res > k) l = mid;
        else
        {
            r = mid;
            if (k - res < 2e5)
            {
                break;
            }
        }

    }

    int res = check(r);
    for (int i = 1 ; i <= n ; ++i)
    {
        pq.push({i, (sqrt(y[i] + 1) - sqrt(y[i]))});
    }

    while (res < k)
    {
        Worker top = pq.top();
        pq.pop();
        y[top.idx]++;
        top.diff = (sqrt(y[top.idx] + 1) - sqrt(y[top.idx]));
        pq.push(top);
        res++;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << y[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
