/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <queue>

#pragma GCC optimize ("O3")

typedef long long llong;
const int MAXN = 1000000 + 10;
const long double EPS = 1e-10;
const int INF  = 1e9;

const int BUFF_SIZE = 1e6;
char buff[BUFF_SIZE];
int buffPos = BUFF_SIZE - 1;

void readChar()
{
    if (++buffPos == BUFF_SIZE) fread(buff, BUFF_SIZE, 1, stdin), buffPos = 0;
}

void readInt(int &num)
{
    num = 0;
    for (; buff[buffPos] < '0' || buff[buffPos] > '9' ; readChar());
    for (; buff[buffPos] >= '0' && buff[buffPos] <= '9' ; readChar())
        num = 10 * num + buff[buffPos] - '0';
}

void readLong(llong &num)
{
    num = 0;
    for (; buff[buffPos] < '0' || buff[buffPos] > '9' ; readChar());
    for (; buff[buffPos] >= '0' && buff[buffPos] <= '9' ; readChar())
        num = 10 * num + buff[buffPos] - '0';
}

void readDouble(long double &num)
{
    num = 0;
    double pw = 1.0;
    bool flag = false;
    for (; buff[buffPos] != '.' && (buff[buffPos] < '0' || buff[buffPos] > '9') ; readChar());
    for (; buff[buffPos] == '.' || (buff[buffPos] >= '0' && buff[buffPos] <= '9') ; readChar())
    {
        if (buff[buffPos] == '.')
        {
            flag = true;
            continue;
        }

        if (!flag) num = 10 * num + buff[buffPos] - '0';
        if (flag)
        {
            pw *= 1e-1;
            num += pw * (buff[buffPos] - '0');
        }
    }
}

int n;
llong k;
llong y[MAXN];
long double x[MAXN];

llong binary(int idx, long double penalty)
{
    if (1.0 / x[idx] < penalty) return 0;
    long double c = x[idx] * penalty;
    // std::cout << "HERE: " << c << ' ' << (c * c) / 4.0 << ' '  << 1.0 / (4.0 * c * c) << '\n';
    llong currY = floor((c > EPS ? (c * c) / 4.0 : 0) + 1.0 / (4.0 * c * c) + 0.5);
    return currY;
}

int check(long double penalty)
{
    int res = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        y[i] = binary(i, penalty);
        res += y[i];
    }

    return res;
}

struct Worker
{
    int idx;
    inline friend bool operator < (const Worker &a, const Worker &b)
    {
        return x[b.idx] * (sqrt(y[a.idx] + 1) - sqrt(y[a.idx])) < x[a.idx] * (sqrt(y[b.idx] + 1) - sqrt(y[b.idx]));
    }
};

std::priority_queue <Worker> pq;
void solve()
{
    long double l = 0.0, r = 2.0, mid;
    while (r - l > EPS)
    {
        mid = (l + r) / 2.0;
        int res = check(mid);
        if (res == k)
        {
            for (int i = 1 ; i <= n ; ++i)
            {
                std::cout << y[i] << ' ';
            }

            std::cout << '\n';
            return;
        }

        if (res > k) l = mid;
        else r = mid;
    }

    int res = check(r);
    for (int i = 1 ; i <= n ; ++i)
    {
        pq.push({i});
    }

    while (res < k)
    {
        Worker top = pq.top();
        pq.pop();
        y[top.idx]++;
        pq.push(top);
        res++;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << y[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    readInt(n);
    readLong(k);
    for (int i = 1 ; i <= n ; ++i)
    {
        readDouble(x[i]);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
