/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <cmath>

typedef long long llong;
const int MOD  = 1050000011;
const int INF  = 1e9;
const int MAXN = 64;

llong power(int num, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (num * power(num, base - 1));
    llong res = power(num, base / 2);
    return res * res;
}

llong n, m;
int max[MAXN];
std::vector <llong> precalc[MAXN];
std::vector <int> dp[MAXN];
std::vector <bool> bl[MAXN];

llong f(int pos, llong last)
{
    if (pos == 1)
    {
        return (m - last + 1) % MOD;
    }

    int from = pow(last, 1.0 / pos);
    if (bl[pos][from])
    {
        return dp[pos][from];
    }

    bl[pos][from] = true;
    for (int i = from ; i <= max[pos] ; ++i)
    {
        if (precalc[pos][i] >= last)
        {
            dp[pos][from] += f(pos - 1, precalc[pos][i]);
            if (dp[pos][from] >= MOD) dp[pos][from] -= MOD;
        }
    }

    return dp[pos][from];
}

void solve()
{
    if (m == 1)
    {
        std::cout << 1 << '\n';
        return;
    }

    int curr = 0;
    while ((1LL << curr + 1) <= m) curr++;
    n = std::min(n, (llong)curr);
    int last = n + 1;

    for (int i = 3 ; last > 1 ; ++i)
    {
        llong pw = 1;
        int log = 0;

        while (pw * i <= m)
        {
            pw *= i;
            log++;
        }

        for (int j = log + 1 ; j <= last ; ++j)
        {
            max[j] = i - 1;
        }

        last = log;
    }

    for (int i = 2 ; i <= n ; ++i)
    {
        bl[i].resize(max[i] + 1, 0);
        dp[i].resize(max[i] + 1, 0);
        precalc[i].resize(max[i] + 1, 0);

        for (int j = 1 ; j <= max[i] ; ++j)
        {
            precalc[i][j] = power(j, i);
        }
    }

    std::cout << f(n, 1) << '\n';
}

void input()
{
    std::cin >> n >> m;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
