/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <cmath>

typedef long long llong;
const int MOD  = 1050000011;
const int INF  = 1e9;
const int MAXN = 64;

llong power(int num, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (num * power(num, base - 1));
    llong res = power(num, base / 2);
    return res * res;
}

llong power2(int num, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (num * power2(num, base - 1)) % MOD;
    llong res = power2(num, base / 2);
    return (res * res) % MOD;
}

llong inv;
llong sumSquares(llong to)
{
    return (((((to % MOD) * ((to + 1) % MOD) % MOD) * ((2 * to + 1) % MOD)) % MOD) * inv) % MOD;
}

llong n, m;
llong max[MAXN];
std::vector <llong> precalc[MAXN];
std::vector <llong> precalc2[MAXN];
std::vector <int> dp[MAXN];
std::vector <bool> bl[MAXN];

llong f(int pos, llong from)
{
    if (from == precalc[pos].size())
    {
        return 0;
    }

    if (pos == 1)
    {
        return (m - from + 1) % MOD;
    }

    if (pos == 2)
    {
        llong l = std::max(1LL, (llong)sqrt(from) - 5);
        while (l * l < from) l++;
        llong r = max[2];
        if (l > r)
        {
            return 0;
        }

        llong ans = ((r - l + 1) * ((m + 1) % MOD)) % MOD;
        ans -= sumSquares(r) - sumSquares(l - 1);
        if (ans < 0) ans += MOD;
        if (ans >= MOD) ans -= MOD;
        return ans;
    }

    if (bl[pos][from])
    {
        return dp[pos][from];
    }

    bl[pos][from] = true;
    dp[pos][from] = f(pos, from + 1) + f(pos - 1, (pos == 3 ? precalc[pos][from] : precalc2[pos][from]));
    if (dp[pos][from] >= MOD) dp[pos][from] -= MOD;
    return dp[pos][from];
}

void solve()
{
    if (m == 1)
    {
        std::cout << 1 << '\n';
        return;
    }

    inv = power2(6, MOD - 2);
    int curr = 0;
    while ((1LL << curr + 1) <= m) curr++;
    n = std::min(n, (llong)curr);
    int last = n + 1;

    for (int i = 3 ; last > 2 ; ++i)
    {
        llong pw = 1;
        int log = 0;

        while (pw <= m / i && pw * i <= m)
        {
            pw *= i;
            log++;
        }

        for (int j = log + 1 ; j <= last ; ++j)
        {
            max[j] = i - 1;
        }

        last = log;
    }

    max[2] = std::max(1LL, (llong)sqrt(m) - 5);
    while (max[2] * max[2] + 2 * max[2] + 1 <= m)
    {
        max[2]++;
    }

    for (int i = 3 ; i <= n ; ++i)
    {
        bl[i].resize(max[i] + 1, 0);
        dp[i].resize(max[i] + 1, 0);
        precalc[i].resize(max[i] + 1, 0);
        precalc2[i].resize(max[i] + 1, 0);

        for (int j = 1 ; j <= max[i] ; ++j)
        {
            precalc[i][j] = power(j, i);
            if (i > 3)
            {
                precalc2[i][j] = precalc2[i][j - 1];
                while (precalc2[i][j] < precalc[i - 1].size() && precalc[i - 1][precalc2[i][j]] < precalc[i][j])
                {
                    precalc2[i][j]++;
                }
            }
        }
    }

    std::cout << f(n, 1) << '\n';
}

void input()
{
    std::cin >> n >> m;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

signed main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

