/*
    Вечеряй, Радо, вечеряй!

    Да ви еба в интерполациите.
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>

#define int long long
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

typedef long long llong;
const int MOD  = 1050000011;
const int INF  = 1e9;
const int MAXN = 64;

llong power(int num, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (num * power(num, base - 1));
    llong res = power(num, base / 2);
    return res * res;
}

llong power2(int num, int base)
{
    if (base == 0) return 1;
    if (base & 1) return (num * power2(num, base - 1)) % MOD;
    llong res = power2(num, base / 2);
    return (res * res) % MOD;
}

llong inv;
llong sumSquares(llong to)
{
    to %= MOD;
    return ((((to * (to + 1) % MOD) * (2 * to + 1)) % MOD) * inv) % MOD;
}

llong n, m;
llong max[MAXN];
std::vector <llong> precalc[MAXN];
std::vector <llong> precalc2[MAXN];
std::vector <int> dp[MAXN];

llong calcTwo(llong from)
{
    llong l = std::max(1LL, (llong)sqrt(from) - 5);
    while (l * l < from) l++;
    llong r = max[2];
    if (l > r)
    {
        return 0;
    }

    llong ans = ((r - l + 1) * ((m + 1) % MOD)) % MOD;
    ans -= sumSquares(r) - sumSquares(l - 1);
    if (ans < 0) ans += MOD;
    if (ans >= MOD) ans -= MOD;
    return ans;
}

double begTime;
void solve()
{
    if (m == 1)
    {
        std::cout << 1 << '\n';
        return;
    }

    inv = power2(6, MOD - 2);
    int curr = 0;
    while ((1LL << curr + 1) <= m) curr++;
    n = std::min(n, (llong)curr);
    int last = n + 1;

    for (int i = 3 ; last > 2 ; ++i)
    {
        llong pw = 1;
        int log = 0;

        while (pw <= m / i && pw * i <= m)
        {
            pw *= i;
            log++;
        }

        for (int j = log + 1 ; j <= last ; ++j)
        {
            max[j] = i - 1;
        }

        last = log;
    }

    max[2] = std::max(1LL, (llong)sqrt(m) - 5);
    while (max[2] * max[2] + 2 * max[2] + 1 <= m)
    {
        max[2]++;
    }

    if (n == 1)
    {
        std::cout << m << '\n';
        return;
    }

    if (n == 2)
    {
        std::cout << calcTwo(1) << '\n';
        return;
    }

    for (int i = 3 ; i <= n ; ++i)
    {
        dp[i].resize(max[i] + 2, 0);
        precalc[i].resize(max[i] + 1, 0);
        precalc2[i].resize(max[i] + 1, 0);

        for (int j = 1 ; j <= max[i] ; ++j)
        {
            precalc[i][j] = power(j, i);
            if (i > 3)
            {
                precalc2[i][j] = precalc2[i][j - 1];
                while (precalc2[i][j] < precalc[i - 1].size() && precalc[i - 1][precalc2[i][j]] < precalc[i][j])
                {
                    precalc2[i][j]++;
                }
            }
        }
    }

    for (int from = max[3] ; from >= 1 ; --from)
    {
        dp[3][from] = dp[3][from + 1] + calcTwo(precalc[3][from]);
        if (dp[3][from] >= MOD) dp[3][from] -= MOD;
    }

    for (int pos = 4 ; pos <= n ; ++pos)
    {
        for (int from = max[pos] ; from >= 1 ; --from)
        {
            dp[pos][from] = dp[pos][from + 1] + dp[pos - 1][precalc2[pos][from]];
            if (dp[pos][from] >= MOD) dp[pos][from] -= MOD;
        }
    }

    // std::cout << "time 1: " << (clock() - begTime) / CLOCKS_PER_SEC << '\n';
    std::cout << dp[n][1] << '\n';
    // std::cout << "time 2: " << (clock() - begTime) / CLOCKS_PER_SEC << '\n';
}

void input()
{
    std::cin >> n >> m;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

signed main()
{
    fastIOI();
    input();
    // begTime = clock();
    solve();

    return 0;
}
