#include <iostream>
#include <algorithm>
#include <map>
#define MAX_N 20005
using namespace std;

short int table[MAX_N][MAX_N];
short int indexi[MAX_N];
short int graf[MAX_N];
int sizeComp[MAX_N];
int perm[MAX_N];
int n;
int q;


int parent(int index)
{
    if(graf[index]==index)
    {
        return index;
    }
    return graf[index]=parent(graf[index]);
}

bool connected(int ind1, int ind2)
{
    return (parent(ind1)==parent(ind2));
}

void editcompsize(int parentin, int newValue)
{
    for(int i=1; i<=n; i++)
    {
        if(connected(parentin, i))
        {
            sizeComp[i]=newValue;
        }
    }
}

void connect(int ind1, int ind2, int &currmax)
{
    int h=sizeComp[ind1];
    if(!connected(ind1, ind2))
    {
        graf[parent(ind1)]=parent(ind2);
        sizeComp[ind1]=sizeComp[ind1]+sizeComp[ind2];
        sizeComp[ind2]=sizeComp[ind1];
        editcompsize(parent(ind2), sizeComp[ind2]);
        //cout << sizeComp[ind1] << " " << sizeComp[ind2] << endl;
        if(sizeComp[ind2]>currmax)
        {
            currmax=sizeComp[ind2];
        }
    }
}


void fill_row(int s)
{
    //cout << "________" << s << endl;
    int index;
    int currmax=1;
    for(int i=s; i<=n; i++)
    {
        graf[i]=i;
        sizeComp[i]=1;
        if(perm[i]+1<=n && indexi[perm[i]+1]<i && indexi[perm[i]+1]>=s)
        {
            //cout << "###" << perm[i]<< endl;
            connect(i, indexi[perm[i]+1], currmax);
        }
        if(perm[i]-1>0 && indexi[perm[i]-1]<i && indexi[perm[i]-1]>=s)
        {
            //cout << "***" <<perm[i] << endl;
            connect(i, indexi[perm[i]-1], currmax);
        }
        table[s][i]=currmax;
    }
}


int main()
{
    cin >> n >> q;

    for(int i=1; i<=n; i++)
    {
        cin >> perm[i];
        indexi[perm[i]]=i;
    }

    int r, l;

    for(int i=1; i<=n; i++)
    {
        fill_row(i);
    }

    for(int i=1; i<=q; i++)
    {
        cin >> l >> r;
        cout << table[l][r] << endl;
    }

    /*for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cout << table[i][j] << " ";
        }
        cout << endl;
    }*/


    return 0;
}
