#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int a[MAXN + 5];
int par[MAXN + 5];
int cnt[MAXN + 5];
int Rank[MAXN + 5];
int used[MAXN + 5];

int find_par(int u)
{
    if (u == par[u]) return u;
    return (par[u] = find_par(par[u]));
}

void unite(int u, int v)
{
    u = find_par(u);
    v = find_par(v);
    if (u == v) return;

    if (Rank[u] < Rank[v]) swap(u, v);
    par[v] = u;
    if (Rank[u] == Rank[v]) Rank[u]++;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r;
        cin >> l >> r;

        for (int j = l; j <= r; ++ j)
        {
            par[a[j]] = a[j];
            cnt[a[j]] = 0;
            used[a[j]] = i;
            Rank[a[j]] = 0;
        }

        for (int j = l; j <= r; ++ j)
        {
            if (a[j] > 1 and used[a[j] - 1] == i) unite(a[j] - 1, a[j]);
        }

        int ans = 0;
        for (int j = l; j <= r; ++ j)
        {
            cnt[find_par(a[j])]++;
            ans = max(ans, cnt[par[a[j]]]);
        }
        cout << ans << endl;
    }

    return 0;
}
