#include <iostream>
#include <cstdio>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int a[MAXN + 5];
int par[MAXN + 5];
int cnt[MAXN + 5];
int Rank[MAXN + 5];
int used[MAXN + 5];

int find_par(int u)
{
    if (u == par[u]) return u;
    return (par[u] = find_par(par[u]));
}

void unite(int u, int v)
{
    u = find_par(u);
    v = find_par(v);
    if (u == v) return;

    if (Rank[u] < Rank[v]) swap(u, v);
    par[v] = u;
    if (Rank[u] == Rank[v]) Rank[u]++;
}

int main()
{
    int n, q;
    scanf("%d%d", &n, &q);

    for (int i = 1; i <= n; ++ i)
    {
        scanf("%d", &a[i]);
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r;
        scanf("%d%d", &l, &r);

        for (int j = l; j <= r; ++ j)
        {
            par[a[j]] = a[j];
            cnt[a[j]] = 0;
            used[a[j]] = i;
            Rank[a[j]] = 0;
        }

        for (int j = l; j <= r; ++ j)
        {
            if (used[a[j] - 1] == i) unite(a[j] - 1, a[j]);
        }

        int ans = 0;
        for (int j = l; j <= r; ++ j)
        {
            cnt[find_par(a[j])]++;
            ans = max(ans, cnt[par[a[j]]]);
        }
        printf("%d\n", ans);
    }

    return 0;
}
