#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

const int BUFFER_LENGTH = 1000000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int read_int()
{
    int ret = 0;
    for (; buffer[buffer_pos] < '0' or '9' < buffer[buffer_pos]; read_char());
    for (; '0' <= buffer[buffer_pos] and buffer[buffer_pos] <= '9'; read_char())
    {
        ret = ret * 10 + (buffer[buffer_pos] - '0');
    }
    return ret;
}

int a[MAXN + 5];
int cnt[MAXN + 5];
int par[MAXN + 5];
int pos[MAXN + 5];
int Rank[MAXN + 5];

int find_par(int u)
{
    if (u == par[u]) return u;
    return (par[u] = find_par(par[u]));
}

void unite(int u, int v)
{
    u = find_par(u);
    v = find_par(v);
    if (u == v) return;

    if (Rank[u] < Rank[v]) swap(u, v);
    par[v] = u;
    if (Rank[u] == Rank[v]) Rank[u]++;
}

int main()
{
    int n, q;
    n = read_int();
    q = read_int();

    for (int i = 1; i <= n; ++ i)
    {
        a[i] = read_int();
        pos[a[i]] = i;
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r;
        l = read_int();
        r = read_int();

        for (int j = l; j <= r; ++ j)
        {
            par[a[j]] = a[j];
            Rank[a[j]] = 0;
            cnt[a[j]] = 0;
        }

        for (int j = l; j <= r; ++ j)
        {
            if (l <= pos[a[j] - 1] and pos[a[j] - 1] <= r) unite(a[j] - 1, a[j]);
        }

        int ans = 0;
        for (int j = l; j <= r; ++ j)
        {
            cnt[find_par(a[j])]++;
            ans = max(ans, cnt[par[a[j]]]);
        }
        cout << ans << endl;
    }

    return 0;
}
