#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

const int BUFFER_LENGTH = 1000000;

char buffer[BUFFER_LENGTH];
int buffer_pos = 0;

void read_char()
{
    if (++ buffer_pos == BUFFER_LENGTH) fread(buffer, 1, BUFFER_LENGTH, stdin), buffer_pos = 0;
}

int read_int()
{
    int ret = 0;
    for (; buffer[buffer_pos] < '0' or '9' < buffer[buffer_pos]; read_char());
    for (; '0' <= buffer[buffer_pos] and buffer[buffer_pos] <= '9'; read_char())
    {
        ret = ret * 10 + (buffer[buffer_pos] - '0');
    }
    return ret;
}

int ans0;
int a[MAXN + 5];
int ans[MAXN + 5];
int pos[MAXN + 5];
int outp[MAXN + 5];
vector< pair<int, int> > queries[MAXN + 5];
int par[MAXN + 5], Rank[MAXN + 5], sz[MAXN + 5];

int find_par(int u)
{
    if (par[u] == u) return u;
    return (par[u] = find_par(par[u]));
}

void unite(int u, int v)
{
    u = find_par(u);
    v = find_par(v);

    if (Rank[u] < Rank[v]) swap(u, v);
    par[v] = u;
    if (Rank[u] == Rank[v]) Rank[u]++;

    sz[u] += sz[v];
    ans0 = max(ans0, sz[u]);
}

int main()
{
    int n, q;
    n = read_int();
    q = read_int();
    ///n = q = 200000;

    for (int i = 1; i <= n; ++ i)
    {
        ///a[i] = i;
        a[i] = read_int();
        pos[a[i]] = i;
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r;
        l = read_int();
        r = read_int();
        ///l = i; r = i + 1000 - 1;
        queries[l].push_back({r, i});
    }

    for (int l = 1; l <= n; ++ l)
    {
        int mx = 0;
        for (auto [r, idx] : queries[l])
        {
            mx = max(mx, r);
        }

        for (int j = l; j <= mx; ++ j)
        {
            par[a[j]] = a[j];
            Rank[a[j]] = 0;
            sz[a[j]] = 1;
        }

        ans[l] = ans0 = 1;
        for (int j = l + 1; j <= mx; ++ j)
        {
            if (l <= pos[a[j] - 1] and pos[a[j] - 1] <= j) unite(a[j], a[j] - 1);
            if (l <= pos[a[j] + 1] and pos[a[j] + 1] <= j) unite(a[j], a[j] + 1);
            ans[j] = ans0;
        }

        for (auto [r, idx] : queries[l])
        {
            outp[idx] = ans[r];
        }
    }

    for (int i = 1; i <= q; ++ i)
    {
        cout << outp[i] << endl;
    }

    return 0;
}
