#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXK = 100;

int ans[MAXN + 5];
int opt[MAXN + 5][MAXK + 5];
long double dp[MAXN + 5][MAXK + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long k;
    cin >> n >> k;

    vector< pair<long double, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        long double x;
        cin >> x;
        v.push_back({x, i});
    }
    sort(v.rbegin(), v.rend());

    for (int j = 0; j <= k; ++ j)
    {
        dp[1][j] = (long double)(sqrt(1.0 * j) / v[0].first);
        opt[1][j] = j;
    }

    for (int i = 2; i <= n; ++ i)
    {
        long double x = v[i - 1].first;
        dp[i][0] = 0.0;
        opt[i][0] = 0;
        for (int j = 1; j <= k; ++ j)
        {
            /**for (int t = 0; t <= j; ++ t)
            {
                if (dp[i][j] < dp[i - 1][t] + (long double)(sqrt(1.0 * (j - t)) / x[i]))
                {
                    dp[i][j] = dp[i - 1][t] + (long double)(sqrt(1.0 * (j - t)) / x[i]);
                    opt[i][j] = j - t;
                }
            }*/
            dp[i][j] = dp[i - 1][j];
            opt[i][j] = opt[i - 1][j];
            int l = 1, r = j + 1, mid;
            while (l < r - 1)
            {
                mid = (l + r) / 2;
                if (dp[i - 1][j - mid] + (long double)(sqrt(1.0 * mid) / x) > dp[i - 1][j - mid + 1] + (long double)(sqrt(1.0 * (mid - 1)) / x)) l = mid;
                else r = mid;
            }
            if (dp[i][j] < dp[i - 1][j - l] + (long double)(sqrt(1.0 * l) / x))
            {
                dp[i][j] = dp[i - 1][j - l] + (long double)(sqrt(1.0 * l) / x);
                opt[i][j] = l;
            }
        }
    }

    for (int i = n; i >= 1; -- i)
    {
        ans[v[i - 1].second] = opt[i][k];
        k -= opt[i][k];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cout << ans[i] << " ";
    }
    cout << endl;

    return 0;
}
