#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const long long MOD = 1050000011;

long long dp[1000005][105], pref[1000005][105];

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

long long solve2(long long m)
{
    long long sq = sqrt(m);
    long long ret = (((sq - 1) * sq % MOD) * (2 * sq - 1) % MOD) * modpow(6, MOD - 2) % MOD;
    ret += (sq - 1) * sq % MOD;
    ret %= MOD;
    ret += (m - sq * sq + 1) % MOD * sq % MOD;
    ret %= MOD;
    return ret;
}

int root(int i, long long m)
{
    int l = 0, r = 1000000001, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        long long num = 1;
        for (int j = 1; j <= i; ++ j)
        {
            if (m / num < mid)
            {
                num = m + 1;
                break;
            }
            else num *= mid;
        }
        if (num <= m) l = mid;
        else r = mid;
    }
    return l;
}

long long pwr(int i, int j)
{
    long long ret = 1;
    while (i--) ret *= j;
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long n, m;
    cin >> n >> m;

    long long n2 = 0, p = 1;
    while (p <= m)
    {
        n2++;
        p *= 2;
    }
    n2--;

    n = min(n, 1ll * n2);

    long long ans = 0;
    for (int j = 1; j <= m; ++ j)
    {
        dp[j][1] = 1;
        if (n == 1) ans = (ans + dp[j][1]) % MOD;
    }
    for (int i = 2; i <= n; ++ i)
    {
        int rt = root(i, m);
        for (int j = 1; j <= rt; ++ j)
        {
            long long rt2 = root(i - 1, m);
            long long rt3 = root(i - 1, pwr(i, j) - 1);
            for (int k = rt3 + 1; k <= rt2; ++ k)
            {
                dp[j][i] = (dp[j][i] + dp[k][i - 1]) % MOD;
            }
            if (i == n) ans = (ans + dp[j][i]) % MOD;
        }
    }
    cout << ans << endl;

    return 0;
}
