#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const long long MOD = 1050000011;

long long dp[1000005][105], pref[1000005][105];

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

long long solve2(long long m)
{
    long long sq = sqrt(m);
    long long ret = (((sq - 1) * sq % MOD) * (2 * sq - 1) % MOD) * modpow(3, MOD - 2) % MOD;
    ret += (sq - 1) * sq / 2 % MOD;
    ret %= MOD;
    ret += (m - sq * sq + 1) % MOD * sq % MOD;
    ret %= MOD;
    return ret;
}

int root(int i, long long m)
{
    int l = 0, r = 1000001, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        long long num = 1;
        for (int j = 1; j <= i; ++ j)
        {
            if (m / num < mid)
            {
                num = m + 1;
                break;
            }
            else num *= mid;
        }
        if (num <= m) l = mid;
        else r = mid;
    }
    return l;
}

long long pwr(int i, int j)
{
    long long ret = 1;
    while (i--) ret *= j;
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long n, m;
    cin >> n >> m;

    long long n2 = 0, p = 1;
    while (p <= m)
    {
        n2++;
        p *= 2;
    }
    n2--;

    n = min(n, 1ll * n2);

    if (n <= 1)
    {
        cout << m % MOD << endl;
        return 0;
    }

    if (n == 2)
    {
        cout << solve2(m) << endl;
        return 0;
    }

    for (int i = 3; i <= n; ++ i)
    {
        int rt = root(i, m);
        if (i == 3)
        {
            long long temp = solve2(m);
            for (int j = 1; j <= rt; ++ j)
            {
                dp[j][i] = temp;
                long long sq = sqrt(1ll * j * j * j - 1);
                dp[j][i] -= ((sq * (sq + 1) % MOD) * (2 * sq + 1) % MOD) * modpow(3, MOD - 2) % MOD;
                dp[j][i] %= MOD;
                if (dp[j][i] < 0) dp[j][i] += MOD;
                dp[j][i] -= sq * (sq + 1) / 2 % MOD;
                dp[j][i] %= MOD;
                if (dp[j][i] < 0) dp[j][i] += MOD;
                dp[j][i] -= (m - (sq + 1) * (sq + 1) + 1) % MOD * sq % MOD;
                dp[j][i] %= MOD;
                if (dp[j][i] < 0) dp[j][i] += MOD;
                pref[j][i] = (pref[j - 1][i] + dp[j][i]) % MOD;
                ///cout << dp[j][i] << endl;
            }
        }
        else
        {
            int rt2 = root(i - 1, m);
            for (int j = 1; j <= rt; ++ j)
            {
                dp[j][i] = pref[rt2][i - 1];
                int rt3 = root(i - 1, pwr(i, j) - 1);
                dp[j][i] -= pref[rt3][i - 1];
                dp[j][i] %= MOD;
                if (dp[j][i] < 0) dp[j][i] += MOD;
                pref[j][i] = (pref[j - 1][i] + dp[j][i]) % MOD;
            }
        }
    }

    cout << pref[root(n, m)][n] << endl;

    return 0;
}
