#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const unsigned long long MOD = 1050000011;

int rev3;
unsigned long long dp[2000005][4], pref[2000005][4];

unsigned long long modpow(unsigned long long a, unsigned long long b)
{
    unsigned long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

unsigned long long solve2(unsigned long long m)
{
    unsigned long long sq = sqrt(m);
    unsigned long long ret = (((sq - 1) * sq % MOD) * (2 * sq - 1) % MOD) * rev3 % MOD;
    ret = (ret + (sq - 1) * sq / 2 % MOD) % MOD;
    ret = (ret + (m - sq * sq + 1) % MOD * sq % MOD) % MOD;
    return ret;
}

int root(int i, unsigned long long m)
{
    int l = 0, r = 1000001, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        unsigned long long num = 1;
        for (int j = 1; j <= i; ++ j)
        {
            if (m / num < mid)
            {
                num = m + 1;
                break;
            }
            else num *= mid;
        }
        if (num <= m) l = mid;
        else r = mid;
    }
    return l;
}

unsigned long long pwr(int i, int j)
{
    unsigned long long ret = 1;
    while (i--) ret *= j;
    return ret;
}

int main()
{
    unsigned long long n, m;
    cin >> n >> m;

    unsigned long long n2 = 0, p = 1;
    while (p <= m)
    {
        n2++;
        p *= 2;
    }
    n2--;

    n = min(n, 1ll * n2);

    if (n <= 1)
    {
        cout << m % MOD << endl;
        return 0;
    }

    rev3 = modpow(3, MOD - 2);

    if (n == 2)
    {
        cout << solve2(m) << endl;
        return 0;
    }

    for (int i = 3; i <= n; ++ i)
    {
        int rt = root(i, m);
        if (i == 3)
        {
            int temp = solve2(m);
            for (int j = 1; j <= rt; ++ j)
            {
                dp[j][0] = temp;
                unsigned long long sq = sqrt(1ll * j * j * j - 1);
                dp[j][0] = ((dp[j][0] - ((sq * (sq + 1) % MOD) * (2 * sq + 1) % MOD) * rev3 % MOD) % MOD + MOD) % MOD;
                dp[j][0] = ((dp[j][0] - sq * (sq + 1) / 2 % MOD) % MOD + MOD) % MOD;
                dp[j][0] = ((dp[j][0] - (m - (sq + 1) * (sq + 1) + 1) % MOD * sq % MOD) % MOD + MOD) % MOD;
                pref[j][0] = (pref[j - 1][0] + dp[j][0]) % MOD;
            }
        }
        else
        {
            int curr = 1 - i % 2;
            int rt2 = root(i - 1, m);
            for (int j = 1; j <= rt; ++ j)
            {
                int rt3 = root(i - 1, pwr(i, j) - 1);
                dp[j][curr] = ((pref[rt2][curr ^ 1] - pref[rt3][curr ^ 1]) % MOD + MOD) % MOD;
                pref[j][curr] = (pref[j - 1][curr] + dp[j][curr]) % MOD;
            }
        }
    }

    cout << pref[root(n, m)][1 - n % 2] << endl;

    return 0;
}
