#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
int n, a[maxn], q, bef[maxn], aft[maxn];

void fix(int idx)
{
    bef[idx] = idx - 1;
    aft[idx] = idx + 1;
}
void solve_query(int l, int r)
{
    for (int i = l; i <= r; i ++)
    {
        fix(a[i]);
        fix(a[i] - 1);
        fix(a[i] + 1);
    }
    for (int i = l; i <= r; i ++)
    {
        int bf = bef[a[i]], af = aft[a[i]];
        bef[af] = bf;
        aft[bf] = af;
    }

    int ans = 0;
    for (int i = l; i <= r; i ++)
    {
        int c = a[i];
        ans = max(ans, aft[c] - bef[c] - 1);
    }

    cout << ans << endl;
}

struct query
{
    int left, right, idx;

    query(int _left = 0, int _right = 0, int _idx = 0)
    {
        left = _left;
        right = _right;
    }
} ask[maxn];

int block_size;
bool cmp(const query &q1, const query &q2)
{
    if (q1.left / block_size < q2.left / block_size)
        return true;
    if (q1.left / block_size > q2.left / block_size)
        return false;
    return q1.right < q2.right;
}


struct node
{
    int max_len, left_len, right_len;
    bool full;
    node()
    {
        max_len = 0;
        left_len = 0;
        right_len = 0;
        full = false;
    }
};

void merge_node(node &nd, node &lf, node &rf)
{
    nd.max_len = max(max(lf.max_len, rf.max_len), lf.right_len + rf.left_len);
    nd.left_len = lf.left_len;
    nd.right_len = rf.right_len;
    if (lf.full)
        nd.left_len = lf.left_len + rf.left_len;
    if (rf.full)
        nd.right_len = rf.right_len + lf.right_len;
    if (lf.full && rf.full)
        nd.full = true;
    else
        nd.full = false;
}

node tree[4 * maxn];
void update(int root, int left, int right, int pos, int val)
{
    while(left != right)
    {
        int mid = (left + right) / 2;
        if (pos <= mid)
            root *= 2, right = mid;
        else
            root = root * 2 + 1, left = mid + 1;
    }

    tree[root].max_len = tree[root].left_len = tree[root].right_len = val;
    tree[root].full = val;

    while(root > 1)
    {
        root /= 2;
        merge_node(tree[root], tree[root * 2], tree[root * 2 + 1]);
    }
    /**if (left == right)
    {
        tree[root].max_len = tree[root].left_len = tree[root].right_len = val;
        tree[root].full = val;
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        update(root * 2, left, mid, pos, val);
    else
        update(root * 2 + 1, mid + 1, right, pos, val);

    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);*/
}

int lf_pt = 1, rf_pt = 0, ans[maxn];
void update_bounds(int left, int right)
{
    ///cout << "query " << left << " " << right << endl;
    while(rf_pt < right)
    {
        rf_pt ++;
        update(1, 1, n, a[rf_pt], 1);
    }

    while(lf_pt > left)
    {
        lf_pt --;
        update(1, 1, n, a[lf_pt], 1);
    }

    while(rf_pt > right)
    {
        update(1, 1, n, a[rf_pt], 0);
        rf_pt --;
    }

    while(lf_pt < left)
    {
        update(1, 1, n, a[lf_pt], 0);
        lf_pt ++;
    }
}
void solve()
{
    ///cout << sqrt(50000) << endl;
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
    }

    if (n <= 100000)
    {
        block_size = sqrt(n);

        for (int i = 1; i <= q; i ++ )
        {
            cin >> ask[i].left >> ask[i].right;
            ask[i].idx = i;
        }
        sort(ask + 1, ask + q + 1, cmp);
        for (int i = 1; i <= q; i ++)
        {
            update_bounds(ask[i].left, ask[i].right);
            ans[ask[i].idx] = tree[1].max_len;
        }


        /// DON'T FORGET TO SORT THE QUERIES AGAIN

        for (int i = 1; i <= q; i ++)
            cout << ans[i] << endl;
    }
    else
    {

        for (int i = 1; i <= n; i ++)
        {
            bef[i] = i - 1;
            aft[i] = i + 1;
        }

        for (int i = 1; i <= q; i ++)
        {
            int l, r;
            cin >> l >> r;
            solve_query(l, r);
        }
    }

}

int main()
{
    speed();
    solve();
    return 0;
}
/**
5 100
3 1 2 4 5
*/
