#include<bits/stdc++.h>
using namespace std;
const int maxn = (1<<18);
struct plat{
    int start, finish;
    plat(){start = finish = 0;}
    plat(int _start, int _finish){
        start = _start;
        finish = _finish;
    }
};
int n, q, a[maxn];
vector<plat> tree[maxn * 2];
void push_into_rez(plat cur, vector<plat> &rez){
    if (rez.back().finish + 1 == cur.start)
        rez.back().finish = cur.finish;
    else rez.push_back(cur);
}
void merge_segments(vector<plat> &v1, vector<plat> &v2, vector<plat> &rez){
    int lp = 0, rp = 0;
    if (v1[lp].start < v2[rp].start){
        rez.push_back(v1[lp]);
        lp++;
    }
    else{
        rez.push_back(v2[rp]);
        rp++;
    }
    plat cur;
    while (lp < v1.size() && rp < v2.size()){
        if (v1[lp].start < v2[rp].start){
            cur = v1[lp];
            lp++;
        }
        else{
            cur = v2[rp];
            rp++;
        }
        push_into_rez(cur, rez);
    }
    while (lp < v1.size()){
        cur = v1[lp];
        lp++;
        push_into_rez(cur, rez);
    }
    while (rp < v2.size()){
        cur = v2[rp];
        rp++;
        push_into_rez(cur, rez);
    }
}
void build_tree(int i, int l, int r){
    if (l == r){
        tree[i].push_back(plat(a[l], a[r]));
        return;
    }
    int mid = (l + r) / 2;
    build_tree(i * 2, l, mid);
    build_tree(i * 2 + 1, mid + 1, r);
    vector<plat> &v1 = tree[i * 2];
    vector<plat> &v2 = tree[i * 2 + 1];
    vector<plat> &rez = tree[i];
    merge_segments(v1, v2, rez);
}
void walkthrough_tree(int i, int l, int r){
    cout << "l == " << l << " r == " << r << "\n";
    for (auto cur: tree[i])
        cout << cur.start << ", " << cur.finish << " ;  ";
    cout << "\n";
    if (l < r){
        int mid = (l + r) / 2;
        walkthrough_tree(i * 2, l, mid);
        walkthrough_tree(i * 2 + 1, mid + 1, r);
    }
}
vector<plat> get_segment(int i, int l, int r, int ql, int qr){
    //cout << "i == " << i << " l == " << l << " r == " << r << " ql == " << ql << " qr == " << qr << "\n";
    if (l == ql && r == qr){
        return tree[i];
    }
    int mid = (l + r) / 2;
    if (qr <= mid){
        //cerr << "case 1\n";
        return get_segment(i * 2, l, mid, ql, qr);}
    if (mid < ql){
        //cerr << "case 2\n";
        return get_segment(i * 2 + 1, mid + 1, r, ql, qr);}
    //cerr << "case 3\n";
    vector <plat>  v1 = get_segment(i * 2, l, mid, ql, mid);
    vector <plat>  v2 = get_segment(i * 2 + 1, mid + 1, r, mid + 1, qr);
    vector <plat> rez;
    merge_segments(v1, v2, rez);
    return rez;
}
int Query(int l, int r){
    vector<plat> seg = get_segment(1, 1, n, l, r);
    int ans = 0;
    for (auto cur: seg)
        ans = max(ans, cur.finish - cur.start + 1);
    return ans;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
        cin >> a[i];
    build_tree(1, 1, n);
    //walkthrough_tree(1, 1, n);
    for (int i = 0; i < q; ++i){
        int l, r;
        cin >> l >> r;
        cout << Query(l, r) << "\n";
    }
	return 0;
}
/*
10 2
3 7 10 8 1 9 2 5 4 6
*/
